{$APPTYPE CONSOLE}

uses SysUtils, Math;

const MaxN = 5000;
      DegRad = Pi/180;
      inf = 1.0*1000*1000*1000;
      r = 6373;

var i, j, n: integer;
    lat, lon, tmp: double;
    maxes, coslat, sinlat, coslon, sinlon, lonlist: array[1..MaxN] of double;
    fi, fo: text;

procedure GetMaxes(i: integer); inline;
begin
  if tmp > maxes[i] then
    maxes[i] := tmp;
//    if maxes[i] > 1 then maxes[i] := 1; {"  ६ 㬥 arccos    1" ()}
end;

begin
  for i := 1 to MaxN do
    maxes[i] := -inf;
  AssignFile(fi, 'input.txt');
  AssignFile(fo, 'output.txt');
  reset(fi);
  rewrite(fo);
  read(fi, n);
  for i := 1 to n do
    begin
      read(fi, lon, lat);
      lon := lon * DegRad; lat := lat * DegRad;
      coslat[i] := cos(lat); sinlat[i] := sin(lat);
      coslon[i] := cos(lon); sinlon[i] := sin(lon);
      lonlist[i] := lon;
      for j := 1 to i-1 do
        begin
          tmp := sinlat[i]*sinlat[j] + coslat[i]*coslat[j] * (coslon[i]*coslon[j] + sinlon[i]*sinlon[j]);
//          tmp := sinlat[i]*sinlat[j] + coslat[i]*coslat[j] * cos(lon - lonlist[j]);
          GetMaxes(i); GetMaxes(j);
        end;

    end;
  for i := 1 to n do
    writeln(fo, arccos(maxes[i])*r:0:3);
  CloseFile(fi);
  CloseFile(fo);
end.
