#include <stdio.h>
#include <algorithm>
#define _USE_MATH_DEFINES
#include <math.h>
#define sqr(x) ((x)*(x))
#include <float.h>
typedef long double real;
using namespace std;
const int MaxN = 5000;
const real DegRad = M_PI / 180;
const int r = 6373;
int i, j, k, l, n, m;
real lat, lon, tmp, maxes[MaxN], coslat[MaxN], sinlat[MaxN], coslon[MaxN], sinlon[MaxN], lonlist[MaxN];
FILE *fi, *fo;

inline void GetMaxes(int &i){
  if(tmp > maxes[i]){
    maxes[i] = tmp;
//    if(maxes[i] > 1) maxes[i] = 1; /*  ६ 㬥 arccos    1" ()*/
  }
}

int main(){
  for(i = 0; i < MaxN; i++){
    maxes[i] = -DBL_MAX;
  }
  fi = fopen("input.txt", "r");
  fo = fopen("output.txt", "w");
  fscanf(fi, "%i", &n);
  for(i = 0; i < n; i++){
    fscanf(fi, "%lf%lf", &lon, &lat);
    lon *= DegRad;
    lat *= DegRad;
    coslat[i] = cos(lat); sinlat[i] = sin(lat);
    coslon[i] = cos(lon); sinlon[i] = sin(lon);
    lonlist[i] = lon;
    for(j = 0; j < i; j++){
//      tmp = sinlat[i]*sinlat[j] + coslat[i]*coslat[j] * (coslon[i]*coslon[j] + sinlon[i]*sinlon[j]);
      tmp = sinlat[i]*sinlat[j] + coslat[i]*coslat[j] * cos(lon - lonlist[j]);
      GetMaxes(i); GetMaxes(j);
    }
  }
  for(i = 0; i < n; i++){
    fprintf(fo, "%0.3lf\n", acos(maxes[i])*r);
  }
  fclose(fi);
  fclose(fo);
  return 0;
}